package com.huiju.welcome.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huiju.welcome.common.base.BaseController;
import com.huiju.welcome.common.base.ResponseBean;
import com.huiju.welcome.model.TaFirstpageContent;
import com.huiju.welcome.service.ITaFirstpageContentService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.http.HttpStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author jobob
 * @since 2019-03-12
 */
@RestController
@RequestMapping("/")
public class TaFirstpageContentController extends BaseController {

    @Autowired
    private ITaFirstpageContentService taFirstpageContentService;

    @ApiOperation(value = "首屏内容映射", notes = "首屏内容映射")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "body", dataType = "Integer", name = "firstpageId", value = "首屏ID"),
            @ApiImplicitParam(paramType = "body", dataType = "Integer", name = "libId", value = "内容ID"),
            @ApiImplicitParam(paramType = "body", dataType = "Integer", name = "weight", value = "权重"),
    })
    @RequestMapping(value = "/firstpage_content", method = RequestMethod.POST)
    public ResponseBean create(@RequestBody TaFirstpageContent taFirstpageContent, HttpServletRequest request) {
        ResponseBean responseBean = new ResponseBean();

        boolean success = taFirstpageContentService.save(taFirstpageContent);
        if (!success) {
            responseBean.addError(HttpStatus.SC_INTERNAL_SERVER_ERROR, "新增内容失败, 请重试");
            return responseBean;
        }

        return responseBean;
    }


    @ApiOperation(value = "首屏内容映射删除", notes = "首屏内容映射删除")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", dataType = "Integer", name = "firstpageId", value = "首屏ID"),
            @ApiImplicitParam(paramType = "path", dataType = "Integer", name = "libId", value = "内容ID")
    })
    @RequestMapping(value = "/firstpage_content/firstpage/{firstpageId}/lib/{libId}", method = RequestMethod.DELETE)
    public ResponseBean delete(TaFirstpageContent taFirstpageContent, HttpServletRequest request) {
        ResponseBean responseBean = new ResponseBean();

        QueryWrapper<TaFirstpageContent> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("firstpage_id", taFirstpageContent.getFirstpageId());
        queryWrapper.eq("lib_id", taFirstpageContent.getLibId());
        boolean success = taFirstpageContentService.remove(queryWrapper);
        if (!success) {
            responseBean.addError(HttpStatus.SC_INTERNAL_SERVER_ERROR, "删除内容失败, 请重试");
            return responseBean;
        }

        return responseBean;
    }
}
