package com.huiju.welcome.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.huiju.welcome.model.TaCustomer;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author jobob
 * @since 2019-06-12
 */
@Mapper
public interface TaCustomerMapper extends BaseMapper<TaCustomer> {

    TaCustomer getCustomerOf(@Param("personId") Integer personId, @Param("realId") Integer realId);
    IPage<TaCustomer> customerPage(IPage<TaCustomer> pg, @Param("customerName") String customerName, @Param("phone") String phone, @Param("platNumber") String platNumber, @Param("agentUserId") Integer agentUserId);

    List<TaCustomer> getCustomersEqualCustomerPage(@Param("customerName") String customerName,  @Param("phone") String phone, @Param("platNumber") String platNumber, @Param("agentUserId") Integer agentUserId);

    List<TaCustomer> getSomeCustMayBe(@Param("plateNumber") String plateNumber, @Param("phone") String phone);

    IPage<TaCustomer> getCustomerListOfFront(IPage<TaCustomer> page, @Param("consultantId") Integer consultantId, @Param("nameOrPhoneOrReceiver") String nameOrPhoneOrReceiver, @Param("customerType") String customerType, @Param("consultantType") Integer consultantType);
    
    IPage<TaCustomer> getAttributionList(IPage<TaCustomer> page);
    
    IPage<TaCustomer> getUnattributionList(IPage<TaCustomer> page);
}
