package com.huiju.welcome.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.huiju.welcome.common.base.ResponseBean;
import com.huiju.welcome.model.SysMenu;
import com.huiju.welcome.model.SysRole;

import java.util.List;

/**
 * 角色业务
 * @author weiximei
 */
public interface ISysRoleService extends IService<SysRole> {

    /**
     * 获取角色
     * @param roleName
     * @return
     */
    ResponseBean getList(String roleName, Integer pageNum, Integer pageSize);

    /**
     * 根据id查询角色
     * @param roleId
     * @return
     */
    ResponseBean getByRoleId(Integer roleId);

    /**
     * 添加或修改
     * @param role
     * @param menuIds
     * @return
     */
    ResponseBean roleSaveOrUpdate(SysRole  role, String [] menuIds);

    /**
     * 查询出所有菜单
     * @return
     */
    ResponseBean getMenus();
}
